*first set working directory - cd 

**urban-rural
foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
capture use caseid perwt age2 educ sex prov_1_ur prov_act_ur using `country'_`year'.dta
if _rc==0 {
display "Begin: `country'" " `year'"
capture drop migr1y
gen byte migr1y=(prov_1_ur!=. & prov_1_ur!=5)
gen byte migr1yi=(prov_1_ur!=. & prov_1_ur==5) 
replace prov_1_ur=prov_act_ur if prov_1_ur==.
capture drop oldresidence
capture drop newresidence
recode prov_1_ur (0=2) (1=1) (9=.) (.=.), gen(oldresidence)  //2 rural 1 urban
recode prov_act_ur (0=2) (1=1) (9=.) (.=.), gen(newresidence)
capture desc migr1y
if _rc==0 {
	capture drop censor_1y
	gen byte censor_1y=migr1y!=0
	expand =2 if censor_1y==1
	sort caseid
	bysort caseid: replace censor_1y=(_n==2) if censor_1y==1
	replace oldresidence=newresidence if oldresidence==. & newresidence!=.
	replace oldresidence=newresidence if migr1y==0
	capture drop UR_1y
	gen UR_1y=cond(censor_1y==1, newresidence, oldresidence)
	lab def urban_rural 1 "Urban" 2 "Rural" ,modify
	lab val UR_1y urban_rural 
	capture drop beg_res
	gen beg_res=0 if migr1y==0 // non-migrants
	capture drop end_res
	gen end_res=1 if migr1y==0 // non-migrants
	replace end_res=0.5 if migr1y==1 & censor_1y==1 // migrants before migration
	replace beg_res=0 if migr1y==1 & censor_1y==1 // migrants before migration
	replace end_res=1 if migr1y==1 & censor_1y==0 // migrants after migration
	replace beg_res=0.5 if migr1y==1 & censor_1y==0 // migrants after migration
	replace end_res=1 if migr1yi==1 // international migrants 
	replace beg_res=0.5 if migr1yi==1 // international migrants
	capture drop censorUR_1y
	gen censorUR_1y=cond(migr1y==0,0, cond(censor_1y==1,oldresidence,0))
	lab def dest_urban_rural 0 "non-mig" 1 "Urban" 2  "Rural", modify
	lab val censorUR_1y dest_urban_rural

forvalue censorUR_1y = 1 / 2 {
	if `censorUR_1y'== 1 { 
		local orig "urban" 
	}
	else { 
		local orig "rural" 
	}
	forvalue UR_1y = 1 / 2 {
		if `UR_1y'== 1 { 
			local dest "urban" 
		}
		else { 
			local dest "rural" 
		}
// define destination (in reverse time = origin)
		quietly stset end_res [pw=perwt] if UR_1y==`UR_1y', ///
					failure(censorUR_1y==`censorUR_1y') time0(beg_res) id(caseid) exit(time .)
		quietly capture stptime if UR_1y==`UR_1y', ///
							per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_100_100_100, replace)
		foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
			quietly capture stptime if UR_1y==`UR_1y' & age2==`age2', ///
								per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_`age2'_100_100, replace)
		} // for each agegroup
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
				quietly capture stptime if UR_1y==`UR_1y' & age2==`age2' & educ==`educ', ///
								per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_`age2'_`educ'_100, replace)
			}
			quietly capture stptime if UR_1y==`UR_1y' & educ==`educ', ///
							per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_100_`educ'_100, replace)
		} 
		foreach sex in 1 2 100 {
			foreach educ in 0 1 2 100 {
				foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					quietly capture stptime if UR_1y==`UR_1y' & age2==`age2' & educ==`educ' & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_`age2'_`educ'_`sex', replace)
					quietly capture stptime if UR_1y==`UR_1y' & age2==`age2'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_`age2'_100_`sex', replace)
				} // for each age
				quietly capture stptime if UR_1y==`UR_1y' & educ==`educ'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_100_`educ'_`sex', replace)
			} // for each educ
			quietly capture stptime if UR_1y==`UR_1y' & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_UR_`orig'_`dest'_100_100_`sex', replace)	
			} // for each sex
		} // for each destination
	} // for each origin
clear
} // if migr1y exists
clear
} // if country and year exists 
clear
} // for each year
clear
} // for each country

foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
foreach orig in urban rural  {
foreach dest in urban rural  {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per1_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture use "`name'", clear
					if _rc==0 {
						capture quietly drop if _group!=0 
						capture quietly drop _group
						capture rename _D migrations
						capture rename _Y PYAR
						capture gen country ="`country'"
						capture gen year = "`year'"
						capture gen period = 1
						capture gen orig = "`orig'"
						capture gen dest = "`dest'"
						capture gen age2 = "`age2'"
						capture gen educ ="`educ'"
						capture gen sex = "`sex'"
						capture recode age2 (1=0) (2=5) (3=10) (4=15) (8=20) (9=25) (10=30) (11=35) (12=40) (13=45) (14=50) (15=55) (16=60) (17=65) (18=70) (19=75) (20=80) , replace
						save "`name'", replace
						}
				clear
				} // sex
			clear
			} // age
		clear
		} // educ
clear
} // destination
clear	
} // origin 
clear
} // year
clear
} // country

* Append 
clear
foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
foreach orig in urban rural   {
foreach dest in urban rural  {
	foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per1_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture append using "`name'"
					capture order country year period orig dest age2 educ sex
			} // age
	} // educ
} // destination
} // origin
} // year 
} // country
}
save Census-UR-In_1, replace

clear
* Erase all small files
foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
foreach orig in urban rural    {
foreach dest in urban rural   {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per1_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture erase "`name'"
					}
		}
		}
	}
}
}
}




///////////////////** census cor in 1 year **/////////////////////////////////////////:
cd "C:/Users/wnie/OneDrive - UCL/global south/africa calibrate rates/1-year in"
clear
foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
capture use caseid perwt age2 educ sex prov_1_cor prov_act_cor using `country'_`year'.dta
if _rc==0 {
display "Begin: `country'" " `year'"
capture drop migr1y
gen byte migr1y=(prov_1_cor!=. & prov_1_cor!=5)
gen byte migr1yi=(prov_1_cor!=. & prov_1_cor==5) 
replace prov_1_cor=prov_act_cor if prov_1_cor==.
capture drop oldresidence
capture drop newresidence
recode prov_1_cor (0=3) (2=1) (3=2) (9=.) (.=.), gen(oldresidence) //3 rural 1 capital 2 other urban 
recode prov_act_cor (0=3) (2=1) (3=2) (9=.) (.=.), gen(newresidence)
capture desc migr1y
if _rc==0 {
	capture drop censor_1y
	gen byte censor_1y=migr1y!=0
	expand =2 if censor_1y==1
	sort caseid
	bysort caseid: replace censor_1y=(_n==2) if censor_1y==1
	replace oldresidence=newresidence if oldresidence==. & newresidence!=.
	replace oldresidence=newresidence if migr1y==0
	capture drop COR_1y
	gen COR_1y=cond(censor_1y==1, newresidence, oldresidence)
	lab def urban_rural 1 "Capital" 2 "Other Urban" 3 "Rural" 4 "Etranger", modify
	lab val COR_1y urban_rural 
	capture drop beg_res
	gen beg_res=0 if migr1y==0 // non-migrants
	capture drop end_res
	gen end_res=1 if migr1y==0 // non-migrants
	replace end_res=0.5 if migr1y==1 & censor_1y==1 // migrants before migration
	replace beg_res=0 if migr1y==1 & censor_1y==1 // migrants before migration
	replace end_res=1 if migr1y==1 & censor_1y==0 // migrants after migration
	replace beg_res=0.5 if migr1y==1 & censor_1y==0 // migrants after migration
	replace end_res=1 if migr1yi==1 // international migrants 
	replace beg_res=0.5 if migr1yi==1 // international migrants
	capture drop censorCOR_1y
	gen censorCOR_1y=cond(migr1y==0,0, cond(censor_1y==1,oldresidence,0))
	lab def dest_urban_rural 0 "non-mig" 1 "Capital" 2 "Other Urban" 3 "Rural", modify
	lab val censorCOR_1y dest_urban_rural

foreach censorCOR_1y in 1 2 3 {
	if `censorCOR_1y'== 1 { 
		local orig "capital" 
	}
	else { 
		if `censorCOR_1y'==2 {
			local orig "otherurban"
		}
		else {
			local orig "rural" 
		}
	} // define origin (in reverse time = destination = failure)
	foreach COR_1y in 1 2 3 {
		if `COR_1y'==1 { 
			local dest "capital" 
		}
		else { 
			if `COR_1y'==2 {
				local dest "otherurban"
			}
			else {
				local dest "rural"
			}
		} // define destination (in reverse time = origin)

		quietly stset end_res [pw=perwt] if COR_1y==`COR_1y', ///
					failure(censorCOR_1y==`censorCOR_1y') time0(beg_res) id(caseid) exit(time .)
		
		quietly capture stptime if COR_1y==`COR_1y', ///
							per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_100_100_100, replace)
		foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
			quietly capture stptime if COR_1y==`COR_1y' & age2==`age2', ///
								per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_`age2'_100_100, replace)
		} // for each agegroup
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
				quietly capture stptime if COR_1y==`COR_1y' & age2==`age2' & educ==`educ', ///
								per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_`age2'_`educ'_100, replace)
			}
		quietly capture stptime if COR_1y==`COR_1y' & educ==`educ', ///
							per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_100_`educ'_100, replace)
		} 
		foreach sex in 1 2 100 {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
		
		quietly capture stptime if COR_1y==`COR_1y' & age2==`age2' & educ==`educ' & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_`age2'_`educ'_`sex', replace)
							
		quietly capture stptime if COR_1y==`COR_1y' & age2==`age2'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_`age2'_100_`sex', replace)
							
		}
		quietly capture stptime if COR_1y==`COR_1y' & educ==`educ'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_100_`educ'_`sex', replace)
							}
			
		quietly capture stptime if COR_1y==`COR_1y' & sex==`sex', ///
							per(1000) output(`country'_`year'_per1_COR_`orig'_`dest'_100_100_`sex', replace)	
		} // for each sex
	} // for each destination
} // for each origin 
clear
} // if migr3y exists
clear
} // if country and year exist
clear
} // for each year
clear 
} // for each country

foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
foreach orig in capital otherurban rural {
foreach dest in capital otherurban rural {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per1_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture use "`name'", clear
					if _rc==0 {
						capture quietly drop if _group!=0 
						capture quietly drop _group
						capture rename _D migrations
						capture rename _Y PYAR
						capture gen country ="`country'"
						capture gen year = "`year'"
						capture gen period = 1
						capture gen orig = "`orig'"
						capture gen dest = "`dest'"
						capture gen age2 = "`age2'"
						capture gen educ ="`educ'"
						capture gen sex = "`sex'"
						capture recode age2 (1=0) (2=5) (3=10) (4=15) (8=20) (9=25) (10=30) (11=35) (12=40) (13=45) (14=50) (15=55) (16=60) (17=65) (18=70) (19=75) (20=80) , replace
						save "`name'", replace
						}
				clear
				} // sex
			clear
			} // age
		clear
		} // educ
clear
} // destination
clear	
} // origin 
clear
} // year
clear
} // country

* Append 
clear
foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
foreach orig in capital otherurban rural   {
foreach dest in capital otherurban rural  {
	foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per1_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture append using "`name'"
					capture order country year period orig dest age2 educ sex
			} // age
	} // educ
} // destination
} // origin
} // year
}
} // country
save Census-COR-In_1, replace


clear
* Erase all small files
foreach country in BF BW KE MW MZ SD TZ ZM {
forvalue year = 1960/2019 {
foreach orig in capital otherurban rural   {
foreach dest in capital otherurban rural   {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per1_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture erase "`name'"
					}
		}
		}
	}
}
}
}
