*first set working directory - cd 

**urban-rural
foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
capture use caseid perwt age2 educ sex migyrs1 prov_3_ur prov_act_ur using `country'_`year'.dta
if _rc==0 {
display "Begin: `country'" " `year'"
capture drop migr3y
gen byte migr3y=(prov_3_ur!=. & prov_3_ur!=5 & migyrs1<=3) //generate migyrs1==1 for rwanda 2012/sl 2004 etc (no migration census) in the original file
gen byte migr3yi=(prov_3_ur!=. & prov_3_ur==5)
replace prov_3_ur=prov_act_ur if prov_3_ur==.
capture drop oldresidence
capture drop newresidence
recode prov_3_ur (1=1)(0=2)(5=3)(9=.)(.=.), gen(oldresidence) //1 urban 2 rural 3 etranger
recode prov_act_ur (1=1)(0=2)(5=3)(9=.)(.=.), gen(newresidence)
*replace migr3y=0 if migyrs1==0 // exclude short-term (<1 year, average 0.5 year) in-migrants 
capture desc migr3y
if _rc==0 {
* taux de migration de plus de 12 mois et de moins de 3 ans:
	capture drop censor_3y
	gen double byte censor_3y=migr3y!=0
	expand =2 if censor_3y==1
	sort caseid
	bysort caseid: replace censor_3y=(_n==1) if censor_3y==1
	replace oldresidence=newresidence if oldresidence==. & newresidence!=.
	replace oldresidence=newresidence if migr3y==0
	capture drop UR_3y
	gen double UR_3y=cond(censor_3y==1, oldresidence, newresidence)
	lab def urban_rural 1 "Urban" 2 "Rural" 3 "Etranger", modify
	lab val UR_3y urban_rural 
	capture drop beg_res
	gen double beg_res=0 if migr3y==0 // non-migrants
	capture drop end_res
	gen double end_res=2.5 if migr3y==0 // non-migrants
	replace end_res=1.25 if migr3y==1 & censor_3y==1 // migrants before migration
	replace beg_res=0 if migr3y==1 & censor_3y==1 // migrants before migration
	replace end_res=2.5 if migr3y==1 & censor_3y==0 // migrants after migration
	replace beg_res=1.25 if migr3y==1 & censor_3y==0 // migrants after migration
	replace end_res=2.5 if migr3yi==1 // international migrants 
	replace beg_res=1.25 if migr3yi==1 // international migrants
	capture drop censorUR_3y
	gen double censorUR_3y=cond(migr3y==0,0, cond(censor_3y==1,newresidence,0))
	lab def dest_urban_rural 0 "non-mig" 1 "Urban" 2 "Rural", modify
	lab val censorUR_3y dest_urban_rural
	compress


forval UR_3y = 1 / 2 {
	if `UR_3y'==1 { 
		local orig "urban" 
	}			
			else {
			local orig "rural" 
		} // define origin
	forval censorUR_3y = 1 / 2 {
		if `censorUR_3y'== 1 { 
			local dest "urban" 
		}			
			else {
			local dest "rural" 
		} // define destination
		
		quietly stset end_res [pw=perwt] if UR_3y==`UR_3y', ///
					failure(censorUR_3y==`censorUR_3y') time0(beg_res) id(caseid) exit(time .)
		
		quietly capture stptime if UR_3y==`UR_3y', ///
							per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_100_100_100, replace)
		foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
			quietly capture stptime if UR_3y==`UR_3y' & age2==`age2', ///
								per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_`age2'_100_100, replace)
		} // for each agegroup
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
				quietly capture stptime if UR_3y==`UR_3y' & age2==`age2' & educ==`educ', ///
								per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_`age2'_`educ'_100, replace)
			}
		quietly capture stptime if UR_3y==`UR_3y' & educ==`educ', ///
							per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_100_`educ'_100, replace)
		} 
		foreach sex in 1 2 100 {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
		
		quietly capture stptime if UR_3y==`UR_3y' & age2==`age2' & educ==`educ' & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_`age2'_`educ'_`sex', replace)
							
		quietly capture stptime if UR_3y==`UR_3y' & age2==`age2'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_`age2'_100_`sex', replace)
							
		}
		quietly capture stptime if UR_3y==`UR_3y' & educ==`educ'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_100_`educ'_`sex', replace)
							}
			
		quietly capture stptime if UR_3y==`UR_3y' & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_UR_`orig'_`dest'_100_100_`sex', replace)	
		} // for each sex
	} // for each destination
} // for each origin 
clear
} // if migr3y exists
clear
} // if country and year exist
clear
} // for each year
clear 
} // for each country

foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
foreach orig in urban rural {
foreach dest in urban rural {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per3_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture use "`name'", clear
					if _rc==0 {
						capture quietly drop if _group!=0 
						capture quietly drop _group
						capture rename _D migrations
						capture rename _Y PYAR
						capture gen country ="`country'"
						capture gen year = "`year'"
						capture gen period = 3
						capture gen orig = "`orig'"
						capture gen dest = "`dest'"
						capture gen age2 = "`age2'"
						capture gen educ ="`educ'"
						capture gen sex = "`sex'"
						capture recode age2 (1=0) (2=5) (3=10) (4=15) (8=20) (9=25) (10=30) (11=35) (12=40) (13=45) (14=50) (15=55) (16=60) (17=65) (18=70) (19=75) (20=80) , replace
						save "`name'", replace
					}
			clear
			} // age
		clear
		} // educ
clear
} // destination
clear
} // origin
clear	
} // year 
clear
}
} // country

* Append 

foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
foreach orig in urban rural {
foreach dest in urban rural {
	foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per3_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture append using "`name'"
					capture order country year period orig dest age2 educ sex
			} // age
	} // educ
} // destination
} // origin
} // year 
} // country
}
save Census-UR-Out_3, replace

clear
* Erase all small files
foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
foreach orig in urban rural  {
foreach dest in urban rural  {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
								foreach sex in 1 2 100 {
					local name "`country'_`year'_per3_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture erase "`name'"
					}
		}
		}
	}
}
}
}

*capital-urban-rural
clear
cd "C:/Users/wnie/OneDrive - UCL/global south/asia calibrate rates/3-year out"
foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
capture use caseid perwt age2 educ sex migyrs1 prov_3_cor prov_act_cor using `country'_`year'.dta
if _rc==0 {
display "Begin: `country'" " `year'"
capture drop migr3y
gen byte migr3y=(prov_3_cor!=. & prov_3_cor!=5 & migyrs1<=3) //generate migyrs1==1 for rwanda 2012/sl 2004 etc (no migration census) in the original file
gen byte migr3yi=(prov_3_cor!=. & prov_3_cor==5)
replace prov_3_cor=prov_act_cor if prov_3_cor==.
capture drop oldresidence
capture drop newresidence
recode prov_3_cor (2=1)(3=2)(0=3)(5=4)(9=.) (.=.), gen(oldresidence) //1 capital 2 urban 3 rural 4 etranger
recode prov_act_cor (2=1)(3=2)(0=3)(5=4)(9=.) (.=.), gen(newresidence)
*replace migr3y=0 if migyrs1==0 // exclude short-term (<1 year, average 0.5 year) in-migrants 
capture desc migr3y
if _rc==0 {
* taux de migration de plus de 12 mois et de moins de 3 ans:
	capture drop censor_3y
	gen double byte censor_3y=migr3y!=0
	expand =2 if censor_3y==1
	sort caseid
	bysort caseid: replace censor_3y=(_n==1) if censor_3y==1
	replace oldresidence=newresidence if oldresidence==. & newresidence!=.
	replace oldresidence=newresidence if migr3y==0
	capture drop COR_3y
	gen double COR_3y=cond(censor_3y==1, oldresidence, newresidence)
	lab def urban_rural 1 "Capital" 2 "Other Urban" 3 "Rural" 4 "Etranger", modify
	lab val COR_3y urban_rural 
	capture drop beg_res
	gen double beg_res=0 if migr3y==0 // non-migrants
	capture drop end_res
	gen double end_res=2.5 if migr3y==0 // non-migrants
	replace end_res=1.25 if migr3y==1 & censor_3y==1 // migrants before migration
	replace beg_res=0 if migr3y==1 & censor_3y==1 // migrants before migration
	replace end_res=2.5 if migr3y==1 & censor_3y==0 // migrants after migration
	replace beg_res=1.25 if migr3y==1 & censor_3y==0 // migrants after migration
	replace end_res=2.5 if migr3yi==1 // international migrants 
	replace beg_res=1.25 if migr3yi==1 // international migrants
	capture drop censorCOR_3y
	gen double censorCOR_3y=cond(migr3y==0,0, cond(censor_3y==1,newresidence,0))
	lab def dest_urban_rural 0 "non-mig" 1 "Capital" 2 "Other Urban" 3 "Rural", modify
	lab val censorCOR_3y dest_urban_rural
	compress


foreach COR_3y in 1 2 3 {
	if `COR_3y'==1 { 
		local orig "capital" 
	}
	else { 
		if `COR_3y'==2 {
			local orig "otherurban"
		}			
			else {
			local orig "rural" 
		}
		} // define origin
	foreach censorCOR_3y in 1 2 3 {
		if `censorCOR_3y'== 1 { 
			local dest "capital" 
		}
		else { 
		if `censorCOR_3y'==2 {
			local dest "otherurban"
		}				
			else {
			local dest "rural" 
		}
		} // define destination
		
		quietly stset end_res [pw=perwt] if COR_3y==`COR_3y', ///
					failure(censorCOR_3y==`censorCOR_3y') time0(beg_res) id(caseid) exit(time .)
		
		quietly capture stptime if COR_3y==`COR_3y', ///
							per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_100_100_100, replace)
		foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
			quietly capture stptime if COR_3y==`COR_3y' & age2==`age2', ///
								per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_`age2'_100_100, replace)
		} // for each agegroup
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
				quietly capture stptime if COR_3y==`COR_3y' & age2==`age2' & educ==`educ', ///
								per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_`age2'_`educ'_100, replace)
			}
		quietly capture stptime if COR_3y==`COR_3y' & educ==`educ', ///
							per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_100_`educ'_100, replace)
		} 
		foreach sex in 1 2 100 {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
		
		quietly capture stptime if COR_3y==`COR_3y' & age2==`age2' & educ==`educ' & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_`age2'_`educ'_`sex', replace)
							
		quietly capture stptime if COR_3y==`COR_3y' & age2==`age2'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_`age2'_100_`sex', replace)
							
		}
		quietly capture stptime if COR_3y==`COR_3y'  & educ==`educ'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_100_`educ'_`sex', replace)
							}
			
		quietly capture stptime if COR_3y==`COR_3y'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per3_COR_`orig'_`dest'_100_100_`sex', replace)	
		} // for each sex
	} // for each destination
} // for each origin 
clear
} // if migr3y exists
clear
} // if country and year exist
clear
} // for each year
clear 
} // for each country

foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
foreach orig in capital otherurban rural {
foreach dest in capital otherurban rural {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per3_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture use "`name'", clear
					if _rc==0 {
						capture quietly drop if _group!=0 
						capture quietly drop _group
						capture rename _D migrations
						capture rename _Y PYAR
						capture gen country ="`country'"
						capture gen year = "`year'"
						capture gen period = 3
						capture gen orig = "`orig'"
						capture gen dest = "`dest'"
						capture gen age2 = "`age2'"
						capture gen educ ="`educ'"
						capture gen sex = "`sex'"
						capture recode age2 (1=0) (2=5) (3=10) (4=15) (8=20) (9=25) (10=30) (11=35) (12=40) (13=45) (14=50) (15=55) (16=60) (17=65) (18=70) (19=75) (20=80) , replace
						save "`name'", replace
					}
			clear
			} // age
		clear
		} // educ
clear
} // destination
clear
} // origin
clear	
} // year 
clear
}
} // country

* Append 

foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
foreach orig in capital otherurban rural {
foreach dest in capital otherurban rural {
	foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per3_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture append using "`name'"
					capture order country year period orig dest age2 educ sex
			} // age
	} // educ
} // destination
} // origin
} // year 
} // country
}
save Census-COR-Out_3, replace

clear
* Erase all small files
foreach country in ID IQ KG MN PH TH {
forvalue year = 1970/2019 {
foreach orig in capital otherurban rural {
foreach dest in capital otherurban rural {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
								foreach sex in 1 2 100 {
					local name "`country'_`year'_per3_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture erase "`name'"
					}
		}
		}
	}
}
}
}
