**UR out
*first set working directory - cd 

clear
foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
capture use caseid perwt age2 educ sex prov_5_ur prov_act_ur using `country'_`year'.dta
if _rc==0 {
display "Begin: `country'" " `year'"
capture drop migr5y
gen byte migr5y=(prov_5_ur!=. & prov_5_ur!=5)
gen byte migr5yi=(prov_5_ur==5) //migr5yi if an individual was abroad 5 years ago or not
replace prov_5_ur=prov_act_ur if prov_5_ur==.
capture drop oldresidence
capture drop newresidence
recode prov_5_ur (0=2) (1=1)(9=.) (.=.), gen(oldresidence) // 1 urban 2 rural
recode prov_act_ur (0=2) (1=1) (9=.) (.=.), gen(newresidence)
capture desc migr5y
if _rc==0 {
	capture drop censor_5y
	gen byte censor_5y=migr5y!=0
	expand =2 if censor_5y==1
	sort caseid
	bysort caseid: replace censor_5y=(_n==1) if censor_5y==1
	replace oldresidence=newresidence if oldresidence==. & newresidence!=.
	replace oldresidence=newresidence if migr5y==0
	capture drop UR_5y
	gen UR_5y=cond(censor_5y==1, oldresidence, newresidence)
	lab def urban_rural 1 "Urban" 2 "Rural", modify
	lab val UR_5y urban_rural 
	capture drop beg_res
	gen beg_res=0 if migr5y==0 // non-migrants
	capture drop end_res
	gen end_res=5 if migr5y==0 // non-migrants
	replace end_res=2.5 if migr5y==1 & censor_5y==1 // migrants before migration
	replace beg_res=0 if migr5y==1 & censor_5y==1 // migrants before migration
	replace end_res=5 if migr5y==1 & censor_5y==0 // migrants after migration
	replace beg_res=2.5 if migr5y==1 & censor_5y==0 // migrants after migration
	replace end_res=5 if migr5yi==1 // international migrants 
	replace beg_res=2.5 if migr5yi==1 // international migrants
	capture drop censorUR_5y
	gen censorUR_5y=cond(migr5y==0,0, cond(censor_5y==1,newresidence,0))
	lab def dest_urban_rural 0 "non-mig" 1 "Urban" 2 "Rural", modify
	lab val censorUR_5y dest_urban_rural
	compress
	
forvalue UR_5y = 1 / 2 {

if `UR_5y'== 1 { 

local orig "urban" 

}

else { 

local orig "rural" 

}

forvalue censorUR_5y = 1 / 2 {

if `censorUR_5y'==1 { 

local dest "urban" 

}

else { 

local dest "rural" 

}
// define destination

		quietly stset end_res [pw=perwt] if UR_5y==`UR_5y', ///
					failure(censorUR_5y==`censorUR_5y') time0(beg_res) id(caseid) exit(time .)
		
		quietly capture stptime if UR_5y==`UR_5y', ///
							per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_100_100_100, replace)
		foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
			quietly capture stptime if UR_5y==`UR_5y' & age2==`age2', ///
								per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_`age2'_100_100, replace)
		} // for each agegroup
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
				quietly capture stptime if UR_5y==`UR_5y' & age2==`age2' & educ==`educ', ///
								per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_`age2'_`educ'_100, replace)
			}
		quietly capture stptime if UR_5y==`UR_5y' & educ==`educ', ///
							per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_100_`educ'_100, replace)
		} 
		foreach sex in 1 2 100 {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
		
		quietly capture stptime if UR_5y==`UR_5y' & age2==`age2' & educ==`educ' & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_`age2'_`educ'_`sex', replace)
							
		quietly capture stptime if UR_5y==`UR_5y' & age2==`age2'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_`age2'_100_`sex', replace)
							
		}
		quietly capture stptime if UR_5y==`UR_5y'  & educ==`educ'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_100_`educ'_`sex', replace)
							}
			
		quietly capture stptime if UR_5y==`UR_5y'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_UR_`orig'_`dest'_100_100_`sex', replace)	
							}
		
		// for each educ
	} 
	// for each destination
} 
// for each origin
} 
// if migr5y exists
clear
} 
// if country_year exists
clear 
} 
// year
clear
} 
// country

foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
foreach orig in urban rural {
foreach dest in urban rural {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per5_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture use "`name'", clear
					if _rc==0 {
						capture quietly drop if _group!=0 
						capture quietly drop _group
						capture rename _D migrations
						capture rename _Y PYAR
						capture gen country ="`country'"
						capture gen year = "`year'"
						capture gen period = 5
						capture gen orig = "`orig'"
						capture gen dest = "`dest'"
						capture gen age2 = "`age2'"
						capture gen educ ="`educ'"
						capture gen sex = "`sex'"
						capture recode age2 (1=0) (2=5) (3=10) (4=15) (8=20) (9=25) ///
								(10=30) (11=35) (12=40) (13=45) (14=50) (15=55) ///
								(16=60) (17=65) (18=70) (19=75) (20=80), replace
						save "`name'", replace
					}
			clear
			} // age
		clear
		} // educ
clear
} // destination
clear
} // origin
clear	
} // year 
clear
} // country
}

* Append 
foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
foreach orig in urban rural   {
foreach dest in urban rural  {
	foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per5_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture append using "`name'"
					capture order country year period orig dest age2 educ sex
			} // age
	} // educ
} // destination
} // origin
} // year 
} // country
}
save Census-UR-Out_5, replace

clear
* Erase all small files
foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
foreach orig in urban rural   {
foreach dest in urban rural   {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per5_UR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture erase "`name'"
					}
		}
		}
	}
}
}
}

**COR out
clear
cd "C:/Users/wnie/OneDrive - UCL/global south/asia calibrate rates/5-year out"
foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
capture use caseid perwt age2 educ sex prov_5_cor prov_act_cor using `country'_`year'.dta
if _rc==0 {
display "Begin: `country'" " `year'"
capture drop migr5y
gen byte migr5y=(prov_5_cor!=. & prov_5_cor!=5)
gen byte migr5yi=(prov_5_cor==5) //migr5yi if an individual was abroad 5 years ago or not
replace prov_5_cor=prov_act_cor if prov_5_cor==.
capture drop oldresidence
capture drop newresidence
recode prov_5_cor (2=1)(3=2)(0=3)(9=.) (.=.), gen(oldresidence) //1 capital 2 urban 3 rural
recode prov_act_cor (2=1)(3=2)(0=3)(9=.) (.=.), gen(newresidence)
capture desc migr5y
if _rc==0 {
	capture drop censor_5y
	gen byte censor_5y=migr5y!=0
	expand =2 if censor_5y==1
	sort caseid
	bysort caseid: replace censor_5y=(_n==1) if censor_5y==1
	replace oldresidence=newresidence if oldresidence==. & newresidence!=.
	replace oldresidence=newresidence if migr5y==0
	capture drop COR_5y
	gen COR_5y=cond(censor_5y==1, oldresidence, newresidence)
	lab def urban_rural 1 "Capital" 2 "Urban" 3 "Rural", modify
	lab val COR_5y urban_rural 
	capture drop beg_res
	gen beg_res=0 if migr5y==0 // non-migrants
	capture drop end_res
	gen end_res=5 if migr5y==0 // non-migrants
	replace end_res=2.5 if migr5y==1 & censor_5y==1 // migrants before migration
	replace beg_res=0 if migr5y==1 & censor_5y==1 // migrants before migration
	replace end_res=5 if migr5y==1 & censor_5y==0 // migrants after migration
	replace beg_res=2.5 if migr5y==1 & censor_5y==0 // migrants after migration
	replace end_res=5 if migr5yi==1 // international migrants 
	replace beg_res=2.5 if migr5yi==1 // international migrants
	capture drop censorCOR_5y
	gen censorCOR_5y=cond(migr5y==0,0, cond(censor_5y==1,newresidence,0))
	lab def dest_urban_rural 0 "non-mig" 1 "Capital" 2 "Urban" 3 "Rural", modify
	lab val censorCOR_5y dest_urban_rural
	compress
	
forvalue COR_5y = 1 / 3 {
		if `COR_5y'== 1 { 
			local orig "capital" 
		}
		else { 
			if `COR_5y'==2 {
				local orig "otherurban"
			}
			else {
				local orig "rural" 
			}
		} 
	forvalue censorCOR_5y = 1 / 3 {
	if `censorCOR_5y'==1 { 
		local dest "capital" 
	}
	else { 
		if `censorCOR_5y'==2 {
			local dest "otherurban"
		}
		else {
			local dest "rural"
		}
	} 

		quietly stset end_res [pw=perwt] if COR_5y==`COR_5y', ///
					failure(censorCOR_5y==`censorCOR_5y') time0(beg_res) id(caseid) exit(time .)
		
		quietly capture stptime if COR_5y==`COR_5y', ///
							per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_100_100_100, replace)
		foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
			quietly capture stptime if COR_5y==`COR_5y' & age2==`age2', ///
								per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_`age2'_100_100, replace)
		} // for each agegroup
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
				quietly capture stptime if COR_5y==`COR_5y' & age2==`age2' & educ==`educ', ///
								per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_`age2'_`educ'_100, replace)
			}
		quietly capture stptime if COR_5y==`COR_5y' & educ==`educ', ///
							per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_100_`educ'_100, replace)
		} 
		foreach sex in 1 2 100 {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 {
		
		quietly capture stptime if COR_5y==`COR_5y' & age2==`age2' & educ==`educ' & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_`age2'_`educ'_`sex', replace)
							
		quietly capture stptime if COR_5y==`COR_5y' & age2==`age2'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_`age2'_100_`sex', replace)
							
		}
		quietly capture stptime if COR_5y==`COR_5y'  & educ==`educ'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_100_`educ'_`sex', replace)
							}
			
		quietly capture stptime if COR_5y==`COR_5y'  & sex==`sex', ///
							per(1000) output(`country'_`year'_per5_COR_`orig'_`dest'_100_100_`sex', replace)	
							}
		
		// for each educ
	} 
	// for each destination
} 
// for each origin
} 
// if migr5y exists
clear
} 
// if country_year exists
clear 
} 
// year
clear
} 
// country

foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
foreach orig in capital otherurban rural {
foreach dest in capital otherurban rural {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per5_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture use "`name'", clear
					if _rc==0 {
						capture quietly drop if _group!=0 
						capture quietly drop _group
						capture rename _D migrations
						capture rename _Y PYAR
						capture gen country ="`country'"
						capture gen year = "`year'"
						capture gen period = 5
						capture gen orig = "`orig'"
						capture gen dest = "`dest'"
						capture gen age2 = "`age2'"
						capture gen educ ="`educ'"
						capture gen sex = "`sex'"
						capture recode age2 (1=0) (2=5) (3=10) (4=15) (8=20) (9=25) ///
								(10=30) (11=35) (12=40) (13=45) (14=50) (15=55) ///
								(16=60) (17=65) (18=70) (19=75) (20=80), replace
						save "`name'", replace
					}
			clear
			} // age
		clear
		} // educ
clear
} // destination
clear
} // origin
clear	
} // year 
clear
} // country
}

* Append 
foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
foreach orig in capital otherurban rural   {
foreach dest in capital otherurban rural  {
	foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per5_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture append using "`name'"
					capture order country year period orig dest age2 educ sex
			} // age
	} // educ
} // destination
} // origin
} // year 
} // country
}
save Census-COR-Out_5, replace

clear
* Erase all small files
foreach country in CN ID /*IL*/ MY NP PH VT {
forvalue year = 1960/2019 {
foreach orig in capital otherurban rural   {
foreach dest in capital otherurban rural   {
		foreach educ in 0 1 2 100 {
			foreach age2 in 1 2 3 4 8 9 10 11 12 13 14 15 16 17 18 19 20 100 {
					foreach sex in 1 2 100 {
					local name "`country'_`year'_per5_COR_`orig'_`dest'_`age2'_`educ'_`sex'.dta"
					capture erase "`name'"
					}
		}
		}
	}
}
}
}